Subject: Re: [PATCH netdev-2.6] jme: JMicron Gigabit Ethernet Driver

From: Stephen Hemminger <[email-masked]>
Date: Thu, 20 Nov 2008 21:20:45 -0800

Going through this driver for net_device_ops makes me wonder
why some other things wer not caught during the review process.

1. Obfuscation by macro which looks like some "vendor support older kernels"
   stuff.  See the wrapping of NAPI and NET_STAT

2. 5 tasklets for thing that could be done by NAPI and one tasklet

3. 4 atomic variables for things that should be already covered by locks

4. 3 locks, seems like more than needed.

5. PCI setup of max read request size should be done via pci_set_readrq
   not by direct manipulation of PCI registers.

6. Not using pci dma allocation which is more standard convention

7. NAPI weight is very large 256 (vs normal 64)